/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Mit Aug 30 12:07:07 CEST 2000
    copyright            : (C) 2000 by Markus Fruehwirth
    email                : 7ox@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SJBclean.h"


/* name: stepone
 * var: MODE (PCM/FRQ), Name of Tempfile
 * exitcode: 0 (for normal termination - returncode)
 * explanation: decides between modes
*/
int
stepone (const char *type, const char *tempfile)
{
  int back = -1;

  if (strcmp (PCM, type) == 0)
    back = -1;			//PCM mode is deactivated
//    back = pcm (tempfile);   //if mode is PCM

  if (strcmp (FRQ, type) == 0)
    back = frq (tempfile);	//if mode is FRQ

  return back;
}


/* name: pcm
 * var: name of tempfile
 * exitcode: 0 (for normal termination - returncode)
 * explanation: cleans pcm data
*/
int
pcm (const char *tempfile)
{
  FILE *original;		//read from this pointer
  FILE *write;			//write to that pointer
  int back;			//return this value to calling funktion
  int cut;			//for cutting that char
  int k, j;			//counter
  int *line;			//a line of the file
  int arezero[PCMSIZE];		//mark of colums that just contain zeros
  int digit;			//current digit
  int cancel;			//break
  int column;			//currently at this column
  int superend;			//break
  int start;			//break
  int zeroline;			//this is a zeroline
  int values[PCMSIZE];		//values of this line
  int singleline;		//this is a line
  int *zerolines;
  int maxzerolines;		//maximum of zerolines
  int thiszeroline;		//currently that much zerolines
  int no;			//break
  int timemem[10];
  int ready;			//break
  char *tfile;			//buffer for filenames

/************INIT*************/
  back = 0;
  ready = 0;
  maxzerolines = 50;
  thiszeroline = 0;
  line = malloc (LINESIZE * sizeof (int));
  zerolines = malloc (maxzerolines * sizeof (int));

  for (k = 0; k < PCMSIZE; k++)
    arezero[k] = 0;
  for (k = 0; k < 10; k++)
    timemem[k] = 0;

  for (k = 0; k < LINESIZE; k++)
    line[k] = 0;
  for (k = 0; k < PCMSIZE; k++)
    values[k] = ZEROS;

  tfile = malloc (256);
  strcpy (tfile, tempfile);
  strcat (tfile, ".1\0");


/**********read file******/
  original = stdin;
  write = fopen (tfile, "w");



  cut = 0;
  while (cut != 84)
    cut = fgetc (original);	//cut beginning of file

  (void) fprintf (write, "T0/");

  while (cut != NEWLINE)	//newLine
    cut = fgetc (original);

//end of first line reached, now read data

  singleline = 0;
  digit = 0;
  cut = 0;
  k = 0;
  superend = 0;
  while (superend == 0)
    {
      column = 0;
      zeroline = 0;
      start = 0;
      while (start == 0)	//for each line
	{
	  cancel = 0;
	  k = 0;
	  while (cancel == 0)	//for each digit
	    {
	      line[k] = fgetc (original);

	      if (line[k] == SLASH)
		cancel = 1;

	      if (line[k] == NEWLINE)
		{
		  start = 1;
		  cancel = 1;
		}

	      if (line[k] == EOF)
		{
		  start = 1;
		  cancel = 1;
		  superend = 1;
		}

	      k++;
	    }
	  digit = makeint (line);
//in digit is now the right digit!!
//digit has to be saved!!!!!
	  if (digit != 0)
	    {
	      arezero[column] = 1;	//for the column
	      zeroline = 1;
	    }
	  if (start == 0)
	    values[column] = digit;
	  column++;
	}
//end of this line:
      if ((zeroline == 1))
	{
	  //print this line, cause it's not a zeroline
	  singleline++;
	  for (k = 0; k < PCMSIZE; k++)
	    (void) fprintf (write, "%d/", values[k]);
	  (void) fprintf (write, "\n");
	}
      if ((zeroline == 0) && (singleline > 0))
	{
	  //print that line, but it is a zeroline
	  if ((thiszeroline + 1) >= maxzerolines)
	    zerolines =
	      realloc (zerolines, (thiszeroline + 2) * sizeof (int));
	  zerolines[thiszeroline] = singleline;
	  thiszeroline++;
	  singleline++;
	  for (k = 0; k < PCMSIZE; k++)
	    (void) fprintf (write, "%d/", values[k]);
	  (void) fprintf (write, "\n");
	}
//zerolines are saved and colums too
//end of this line
      if (superend == 0)	//if not EOF
	{
	  digit = 0;
	  no = 0;
	  k = 0;
	  while (digit != NEWLINE)
	    {
	      digit = fgetc (original);
	      if (digit == MINUS)	//digit is negativ and wrong
		{
		  no = 1;	//replaced by value of the line before
		  for (j = 1; j < ready; j++)
		    (void) fprintf (write, "%c", timemem[j]);
		}
	      if (digit == EOF)
		{
		  digit = NEWLINE;
		  superend = 1;
		}
	      if (digit == NEWLINE)
		{
		  (void) fprintf (write, "/");
		}
	      if (digit == LETTERC)
		no = 1;
	      if (no == 0)
		{
		  timemem[k] = digit;
		  if (digit != 84)
		    ready = k + 1;
//if not a zeroline
		  if (zeroline != 0)	//line added now
		    (void) fprintf (write, "%c", digit);
		}
	      k++;
	    }
	}
//read next line
    }
//all zeroline in zerolines[]
//alle zerocolumns in arezero[]

  (void) fclose (write);

//do now final file
  start = 0;
//delete at which line
  if (thiszeroline == 0)
    {
      start = 1;
      cancel = 0;
    }
  else
    {
      thiszeroline--;
      cancel = zerolines[thiszeroline];	//this is the last real value
    }
  if (thiszeroline == 0)
    start = 1;
  while (start == 0)
    {
      thiszeroline--;
      if (cancel == (zerolines[thiszeroline] + 1))
	cancel = zerolines[thiszeroline];
      else
	start = 1;
      if (thiszeroline == 0)
	start = 1;
    }
//in cancel is now the number of the line in which contains the last real data
//if no zerolines present (unbelievable) it contains 0
  if (cancel != 0)
    cancel++;


  write = NULL;
  write = stdout;

  original = NULL;
  strcpy (tfile, tempfile);
  strcat (tfile, ".1\0");
  original = fopen (tfile, "r");
//filepointer again open!

//will write coulumns now
  for (k = 0; k < PCMSIZE; k++)
    (void) fprintf (write, "%d/", arezero[k]);
  (void) fprintf (write, "\n");

  singleline = 1;
  while (singleline > 0)
    {
      start = fgetc (original);
      if (start == -1)
	singleline = 0;
      if (start == NEWLINE)
	singleline++;
      if (cancel == singleline)
	singleline = 0;
      if (singleline > 0)
	(void) fprintf (write, "%c", start);
    }

  (void) fclose (original);
  (void) fflush (write);

//finished

  return back;
}

/* name: frq
 * var: name of Tempfile
 * exitcode:0 (for normal termination - returncode)
 * explanation: cleans pcm data
*/
int
frq (const char *tempfile)
{
  FILE *original;		//read from this pointer
  FILE *write;			//write to that pointer
  int back;			//return this value to calling funktion
  int cut;			//for cutting that char
  int k, j;			//counter
  int *line;			//a line of the file
  int arezero[FRQSIZE];		//mark of colums that just contain zeros
  int digit;			//current digit
  int cancel;			//break
  int column;			//currently at this column
  int superend;			//break
  int start;			//break
  int zeroline;			//this is a zeroline
  int values[FRQSIZE];		//values of this line
  int singleline;		//this is a line
  int *zerolines;
  int maxzerolines;		//maximum of zerolines
  int thiszeroline;		//currently that much zerolines
  int no;			//break
  int timemem[10];
  int ready;			//break
  char *tfile;			//buffer for filenames

/**************INIT********************/
  ready = 0;
  back = 0;
  maxzerolines = 50;
  thiszeroline = 0;
  line = malloc (LINESIZE * sizeof (int));
  zerolines = malloc (maxzerolines * sizeof (int));

  for (k = 0; k < FRQSIZE; k++)
    arezero[k] = 0;
  for (k = 0; k < 10; k++)
    timemem[k] = 0;
  for (k = 0; k < LINESIZE; k++)
    line[k] = 0;
  for (k = 0; k < FRQSIZE; k++)
    values[k] = ZEROS;

  tfile = malloc (256);
  strcpy (tfile, tempfile);
  strcat (tfile, ".1\0");

  original = stdin;
//original = fopen("/home/markus/Diplomarbeit/dev/a.frq.links", "r");
  write = fopen (tfile, "w");

  cut = 0;
  while (cut != 84)		//cut beginning
    cut = fgetc (original);
  (void) fprintf (write, "T0/");

  while (cut != NEWLINE)
    cut = fgetc (original);

//end of first line now start with data
  singleline = 0;
  digit = 0;
  cut = 0;
  k = 0;
  superend = 0;
  while (superend == 0)
    {
      column = 0;
      zeroline = 0;
      start = 0;
      while (start == 0)	//lines
	{
	  cancel = 0;
	  k = 0;
	  while (cancel == 0)	//single digits
	    {
	      line[k] = fgetc (original);

	      if (line[k] == SLASH)
		cancel = 1;

	      if (line[k] == NEWLINE)
		{
		  start = 1;
		  cancel = 1;
		}

	      if (line[k] == EOF)
		{
		  start = 1;
		  cancel = 1;
		  superend = 1;
		}

	      k++;
	    }
	  digit = makeint (line);
//in digit is now the right digit!!
//digit has to be saved!!!!!
	  if (digit != 0)
	    {
	      arezero[column] = 1;	//columns
	      zeroline = 1;
	    }
	  if (start == 0)
	    values[column] = digit;
	  column++;
	}
//end of line
      if ((zeroline == 1))
	{
	  //print line, no zeroline
	  singleline++;
	  for (k = 0; k < FRQSIZE; k++)
	    (void) fprintf (write, "%d/", values[k]);
	  (void) fprintf (write, "\n");
	}
      if ((zeroline == 0) && (singleline > 0))
	{
	  //print line, but zero line
	  if ((thiszeroline + 1) >= maxzerolines)
	    zerolines =
	      realloc (zerolines, (thiszeroline + 2) * sizeof (int));
	  zerolines[thiszeroline] = singleline;
	  thiszeroline++;
	  singleline++;
	  for (k = 0; k < FRQSIZE; k++)
	    (void) fprintf (write, "%d/", values[k]);
	  (void) fprintf (write, "\n");
	}
//zerolines are saved and colums too
//end of this line
      if (superend == 0)	//not eof
	{
	  digit = 0;
	  no = 0;
	  k = 0;
	  while (digit != NEWLINE)
	    {
	      digit = fgetc (original);
	      if (digit == MINUS)	//digit is negativ and this is wrong
		{
		  no = 1;	//replaced by last value
		  for (j = 1; j < ready; j++)
		    (void) fprintf (write, "%c", timemem[j]);
		}
	      if (digit == EOF)
		{
		  digit = NEWLINE;
		  superend = 1;
		}
	      if (digit == NEWLINE)
		{
//if not zeroline
		  if ((zeroline != 0) && (singleline > 0))	//line added now
		    (void) fprintf (write, "/");
		}
	      if (digit == LETTERC)
		no = 1;
	      if (no == 0)
		{
		  timemem[k] = digit;
		  if (digit != 84)
		    ready = k + 1;
//if not zeroline
		  if ((zeroline != 0) && (singleline > 0))	//line added now
		    (void) fprintf (write, "%c", digit);
		}
	      k++;
	    }
	}
//next line to read
    }
//all zeroline in zerolines[]
//alle zerocolumns in arezero[]

  (void) fclose (write);

//do final File now
  start = 0;
//delete strating with which line
  if (thiszeroline == 0)
    {
      start = 1;
      cancel = 0;
    }
  else
    {
      thiszeroline--;
      cancel = zerolines[thiszeroline];	//last valid value
    }
  if (thiszeroline == 0)
    start = 1;
  while (start == 0)
    {
      thiszeroline--;
      if (cancel == (zerolines[thiszeroline] + 1))
	cancel = zerolines[thiszeroline];
      else
	start = 1;
      if (thiszeroline == 0)
	start = 1;
    }
//cancel contains now the last valid line
  if (cancel != 0)
    cancel++;

  write = NULL;
  write = stdout;

  original = NULL;
  strcpy (tfile, tempfile);
  strcat (tfile, ".1\0");
  original = fopen (tfile, "r");
//filepointer open

//colums printed
  for (k = 0; k < FRQSIZE; k++)
    (void) fprintf (write, "%d/", arezero[k]);
  (void) fprintf (write, "\n");

  singleline = 1;
  while (singleline > 0)
    {
      start = fgetc (original);
      if (start == -1)
	singleline = 0;
      if (start == NEWLINE)
	singleline++;
      if (cancel == singleline)
	singleline = 0;
      if (singleline > 0)
	(void) fprintf (write, "%c", start);
    }

  (void) fclose (original);
  (void) fflush (write);

  return back;
}


/* name:makeint
 * var: line: contains the number to convert
 * exitcode: the converted integer
 * explanation: to convert a string to an integer (range: 0-999)
*/
int
makeint (int *line)
{
  int result;			//result of conversion
  int k;			//counter
  int cancel;			//break
  int factor;			//multiply by that factor
  int temp;			//temp value
  int dig;
  int convert[LINESIZE];	//copy of convert array
  int sign;

  for (k = 0; k < LINESIZE; k++)
    convert[k] = 0;
  sign = 1;
  result = 0;
  cancel = 0;
  for (k = 0; k < LINESIZE; k++)
    line[k] = line[k] - ZEROS;

  temp = 0;
  k = 0;
  dig = 0;
  factor = 1;

  while (cancel == 0)
    {
      temp = line[k];
      if ((temp < 0) || (temp > 10))
	/*  not a number */
	cancel = 1;
      else
	{
	  convert[k] = temp;
	  dig++;
	}
      if ((k == 0) && (temp == -3))
	{
	  sign = -1;
	  cancel = 0;
	  convert[k] = 0;
	  dig++;
	}
      k++;
    }
  while (dig > 0)
    {
      dig--;			// this line is OK!
      result = result + convert[dig] * factor;
      factor = factor * 10;
    }

  return (result * sign);
}


/* name: main
 * var: argv[1]	Mode (PCM/FRQ)
 *		argv[2]	Name of Tempfile
 * exitcode: 0	success
 * explanation: calls stepone with arguments
*/
int
main (int argc, char *argv[])
{
  int back = -1;

//  printf("hier");

  if (argc == 3)
    back = stepone (argv[1], argv[2]);

  if (argc < 3)
    {
      
	(void) fprintf (stderr, "%s: wrong Usage: %s filename FRQ tempfile\n",
			argv[0], argv[0]);
      exit (EXIT_FAILURE);
    }

  return back;
}
